# generated by datamodel-codegen:
#   filename:  openapi.json
#   timestamp: 2021-11-18T18:21:31+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import Field

from kelvin.sdk.client.base_model import BaseModelRoot
from kelvin.sdk.client.data_model import DataModelBase


class ACPLocationItem(DataModelBase):
    """
    ACPLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ACPMetadataBulkCreateItem(DataModelBase):
    """
    ACPMetadataBulkCreateItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataBulkDeleteItem(DataModelBase):
    """
    ACPMetadataBulkDeleteItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None


class ACPMetadataCreate(DataModelBase):
    """
    ACPMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataUpdate(DataModelBase):
    """
    ACPMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ACPSettingsAutoUpdate(DataModelBase):
    """
    ACPSettingsAutoUpdate object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingsMetrics(DataModelBase):
    """
    ACPSettingsMetrics object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingsStatus(DataModelBase):
    """
    ACPSettingsStatus object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPStatusUpdate(DataModelBase):
    """
    ACPStatusUpdate object.

    Parameters
    ----------
    message: Optional[str]
    state: Optional[str]
    warnings: Optional[List[str]]

    """

    message: Optional[str] = None
    state: Optional[str] = None
    warnings: Optional[List[str]] = None


class ACPUpdate(DataModelBase):
    """
    ACPUpdate object.

    Parameters
    ----------
    location: Optional[ACPLocationItem]
    manifests_scrape_enabled: Optional[bool]
    manifests_scrape_interval: Optional[int]
    metrics_enabled: Optional[bool]
    metrics_scrape_interval: Optional[int]
    status_scrape_enabled: Optional[bool]
    status_scrape_interval: Optional[int]
    title: Optional[str]

    """

    location: Optional[ACPLocationItem] = None
    manifests_scrape_enabled: Optional[bool] = None
    manifests_scrape_interval: Optional[int] = None
    metrics_enabled: Optional[bool] = None
    metrics_scrape_interval: Optional[int] = None
    status_scrape_enabled: Optional[bool] = None
    status_scrape_interval: Optional[int] = None
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassCreate(DataModelBase):
    """
    AlarmClassCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassUpdate(DataModelBase):
    """
    AlarmClassUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class AlarmCreate(DataModelBase):
    """
    AlarmCreate object.

    Parameters
    ----------
    alarm_type_name: Optional[str]
    asset_name: Optional[str]
    created_by: Optional[str]
    description: Optional[str]
    related_asset_names: Optional[List[str]]
    severity: Optional[int]
    solution: Optional[str]
    title: Optional[str]

    """

    alarm_type_name: Optional[str] = None
    asset_name: Optional[str] = None
    created_by: Optional[str] = None
    description: Optional[str] = None
    related_asset_names: Optional[List[str]] = None
    severity: Optional[int] = None
    solution: Optional[str] = None
    title: Optional[str] = None


class AlarmFilterCreate(DataModelBase):
    """
    AlarmFilterCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    username: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    username: Optional[str] = None
    version: Optional[str] = None


class AlarmFilterUpdate(DataModelBase):
    """
    AlarmFilterUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    version: Optional[str] = None


class AlarmList(DataModelBase):
    """
    AlarmList object.

    Parameters
    ----------
    acknowledged_at_end: Optional[datetime]
    acknowledged_at_start: Optional[datetime]
    acknowledged_by: Optional[List[str]]
    alarm_class_names: Optional[List[str]]
    alarm_severities: Optional[List[int]]
    alarm_statuses: Optional[List[str]]
    alarm_type_names: Optional[List[str]]
    asset_class_names: Optional[List[str]]
    asset_include_children: Optional[bool]
    asset_names: Optional[List[str]]
    asset_type_names: Optional[List[str]]
    created_at_end: Optional[datetime]
    created_at_start: Optional[datetime]
    created_by: Optional[List[str]]
    resolved_at_end: Optional[datetime]
    resolved_at_start: Optional[datetime]
    resolved_by: Optional[List[str]]

    """

    acknowledged_at_end: Optional[datetime] = None
    acknowledged_at_start: Optional[datetime] = None
    acknowledged_by: Optional[List[str]] = None
    alarm_class_names: Optional[List[str]] = None
    alarm_severities: Optional[List[int]] = None
    alarm_statuses: Optional[List[str]] = None
    alarm_type_names: Optional[List[str]] = None
    asset_class_names: Optional[List[str]] = None
    asset_include_children: Optional[bool] = None
    asset_names: Optional[List[str]] = None
    asset_type_names: Optional[List[str]] = None
    created_at_end: Optional[datetime] = None
    created_at_start: Optional[datetime] = None
    created_by: Optional[List[str]] = None
    resolved_at_end: Optional[datetime] = None
    resolved_at_start: Optional[datetime] = None
    resolved_by: Optional[List[str]] = None


class AlarmTypeCreate(DataModelBase):
    """
    AlarmTypeCreate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmTypeUpdate(DataModelBase):
    """
    AlarmTypeUpdate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmUpdateStatus(DataModelBase):
    """
    AlarmUpdateStatus object.

    Parameters
    ----------
    action: Optional[str]

    """

    action: Optional[str] = None


class AppCreate(DataModelBase):
    """
    AppCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class AppUpdate(DataModelBase):
    """
    AppUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AssetClassCreate(DataModelBase):
    """
    AssetClassCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AssetClassUpdate(DataModelBase):
    """
    AssetClassUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class AssetLocationItem(DataModelBase):
    """
    AssetLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class AssetPropertyCreate(DataModelBase):
    """
    AssetPropertyCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)
    value: Optional[str] = None


class AssetTemplateProperties(DataModelBase):
    """
    AssetTemplateProperties object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = None
    title: Optional[str] = None
    value: Optional[str] = None


class AssetTypeCreate(DataModelBase):
    """
    AssetTypeCreate object.

    Parameters
    ----------
    asset_class_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    asset_class_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AssetTypeMetadataCreate(DataModelBase):
    """
    AssetTypeMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class AssetTypeMetadataUpdate(DataModelBase):
    """
    AssetTypeMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class AssetTypeUpdate(DataModelBase):
    """
    AssetTypeUpdate object.

    Parameters
    ----------
    asset_class_name: Optional[str]
    title: Optional[str]

    """

    asset_class_name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class BridgeDeploy(DataModelBase):
    """
    BridgeDeploy object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    protocol: Optional[str]
    title: Optional[str]

    """

    acp_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None
    protocol: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class ClusterLocationItem(DataModelBase):
    """
    ClusterLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ClusterUpdate(DataModelBase):
    """
    ClusterUpdate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    network_info: Optional[Dict[str, Any]]
    ready: Optional[bool]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    ready: Optional[bool] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class Type(Enum):
    user = "user"
    workload = "workload"


class DataLabelSource(DataModelBase):
    """
    DataLabelSource object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    type: Optional[Type]

    """

    info: Optional[Dict[str, Any]] = None
    type: Optional[Type] = None


class DeleteSelector(DataModelBase):
    """
    DeleteSelector object.

    Parameters
    ----------
    asset_name: str
    name: str

    """

    asset_name: str = Field(..., max_length=64)
    name: str = Field(..., max_length=64)


class FailureDetectionProperty(DataModelBase):
    """
    FailureDetectionProperty object.

    Parameters
    ----------
    name: Optional[str]
    unit: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = None
    unit: Optional[str] = None
    value: Optional[str] = None


class FailureDetectionTemplate(DataModelBase):
    """
    FailureDetectionTemplate object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]

    """

    enabled: Optional[bool] = None
    failure_class_name: Optional[str] = None


class GraphDependencies(DataModelBase):
    """
    GraphDependencies object.

    Parameters
    ----------
    collection: Optional[str]
    name: Optional[str]

    """

    collection: Optional[str] = None
    name: Optional[str] = None


class ICDField(DataModelBase):
    """
    ICDField object.

    Parameters
    ----------
    array: Optional[bool]
    description: Optional[str]
    name: Optional[str]
    type: Optional[str]

    """

    array: Optional[bool] = None
    description: Optional[str] = None
    name: Optional[str] = None
    type: Optional[str] = None


class ICDPayload(DataModelBase):
    """
    ICDPayload object.

    Parameters
    ----------
    class_name: Optional[str]
    description: Optional[str]
    fields: Optional[List[ICDField]]
    name: Optional[str]
    version: Optional[str]

    """

    class_name: Optional[str] = None
    description: Optional[str] = None
    fields: Optional[List[ICDField]] = None
    name: Optional[str] = None
    version: Optional[str] = None


class LabelCreate(DataModelBase):
    """
    LabelCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class LabelMetadataBulkCreateItem(DataModelBase):
    """
    LabelMetadataBulkCreateItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    label_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class LabelMetadataCreate(DataModelBase):
    """
    LabelMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class LabelMetadataDeleteBulkItem(DataModelBase):
    """
    LabelMetadataDeleteBulkItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]

    """

    label_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)


class LabelMetadataUpdate(DataModelBase):
    """
    LabelMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class LabelUpdate(DataModelBase):
    """
    LabelUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class Metric(DataModelBase):
    """
    Metric object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]

    """

    asset_name: Optional[str] = None
    name: Optional[str] = None


class MetricCreate(DataModelBase):
    """
    MetricCreate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    name: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = None
    data_type_version: Optional[str] = None
    display_unit: Optional[str] = None
    name: Optional[str] = Field(None, max_length=64)
    semantic_type_name: Optional[str] = None
    semantic_type_properties: Optional[Dict[str, Any]] = None
    title: Optional[str] = Field(None, max_length=64)
    write: Optional[bool] = None


class MetricUpdate(DataModelBase):
    """
    MetricUpdate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = None
    data_type_version: Optional[str] = None
    display_unit: Optional[str] = Field(None, max_length=64)
    semantic_type_name: Optional[str] = None
    semantic_type_properties: Optional[Dict[str, Any]] = None
    title: Optional[str] = Field(None, max_length=64)
    write: Optional[bool] = None


class SecretCreate(DataModelBase):
    """
    SecretCreate object.

    Parameters
    ----------
    name: str
    value: str

    """

    name: str = Field(..., max_length=32)
    value: str


class StorageCreate(DataModelBase):
    """
    StorageCreate object.

    Parameters
    ----------
    asset_name: str
    data_type: str
    id: Optional[str]
    name: str
    payload: Dict[str, Any]
    source: Optional[str]
    target: Optional[str]
    timestamp: datetime

    """

    asset_name: str = Field(..., max_length=64)
    data_type: str = Field(..., max_length=64)
    id: Optional[str] = None
    name: str = Field(..., max_length=64)
    payload: Dict[str, Any]
    source: Optional[str] = Field(None, max_length=256)
    target: Optional[str] = Field(None, max_length=256)
    timestamp: datetime


class StorageDelete(DataModelBase):
    """
    StorageDelete object.

    Parameters
    ----------
    end_time: datetime
    selectors: List[DeleteSelector]
    start_time: datetime

    """

    end_time: datetime
    selectors: List[DeleteSelector]
    start_time: datetime


class Order(Enum):
    ASC = "ASC"
    DESC = "DESC"


class StorageSelector(DataModelBase):
    """
    StorageSelector object.

    Parameters
    ----------
    asset_name: str
    fields: Optional[List[str]]
    name: str

    """

    asset_name: str = Field(..., max_length=64)
    fields: Optional[List[str]] = None
    name: str = Field(..., max_length=64)


class StorageUpdate(DataModelBase):
    """
    StorageUpdate object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    asset_name: Optional[str] = None
    name: Optional[str] = None
    title: Optional[str] = None


class ViewGroupCreate(DataModelBase):
    """
    ViewGroupCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    views: Optional[List[str]]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)
    views: Optional[List[str]] = None


class ViewGroupMetadataBulkCreateItem(DataModelBase):
    """
    ViewGroupMetadataBulkCreateItem object.

    Parameters
    ----------
    group_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    group_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ViewGroupMetadataBulkDeleteItem(DataModelBase):
    """
    ViewGroupMetadataBulkDeleteItem object.

    Parameters
    ----------
    group_name: Optional[str]
    name: Optional[str]

    """

    group_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)


class ViewGroupMetadataCreate(DataModelBase):
    """
    ViewGroupMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ViewGroupMetadataUpdate(DataModelBase):
    """
    ViewGroupMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ViewGroupUpdate(DataModelBase):
    """
    ViewGroupUpdate object.

    Parameters
    ----------
    title: Optional[str]
    views: Optional[List[str]]

    """

    title: Optional[str] = Field(None, max_length=64)
    views: Optional[List[str]] = None


class ViewMetadataBulkCreateItem(DataModelBase):
    """
    ViewMetadataBulkCreateItem object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    view_name: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None
    view_name: Optional[str] = Field(None, max_length=64)


class ViewMetadataBulkDeleteItem(DataModelBase):
    """
    ViewMetadataBulkDeleteItem object.

    Parameters
    ----------
    name: Optional[str]
    view_name: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    view_name: Optional[str] = Field(None, max_length=64)


class ViewMetadataCreate(DataModelBase):
    """
    ViewMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ViewMetadataUpdate(DataModelBase):
    """
    ViewMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ViewMetrics(DataModelBase):
    """
    ViewMetrics object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]

    """

    asset_name: Optional[str] = None
    name: Optional[str] = None


class ViewTypeCreate(DataModelBase):
    """
    ViewTypeCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class ViewTypeMetadataBulkCreateItem(DataModelBase):
    """
    ViewTypeMetadataBulkCreateItem object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    type_name: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None
    type_name: Optional[str] = Field(None, max_length=64)


class ViewTypeMetadataBulkDeleteItem(DataModelBase):
    """
    ViewTypeMetadataBulkDeleteItem object.

    Parameters
    ----------
    name: Optional[str]
    type_name: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    type_name: Optional[str] = Field(None, max_length=64)


class ViewTypeMetadataCreate(DataModelBase):
    """
    ViewTypeMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ViewTypeMetadataUpdate(DataModelBase):
    """
    ViewTypeMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ViewTypeUpdate(DataModelBase):
    """
    ViewTypeUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class ViewUpdate(DataModelBase):
    """
    ViewUpdate object.

    Parameters
    ----------
    metrics: Optional[List[ViewMetrics]]
    title: Optional[str]
    view_type_name: Optional[str]

    """

    metrics: Optional[List[ViewMetrics]] = None
    title: Optional[str] = Field(None, max_length=64)
    view_type_name: Optional[str] = Field(None, max_length=64)


class WireguardPeerCreate(DataModelBase):
    """
    WireguardPeerCreate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    name: str
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    name: str
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardPeerUpdate(DataModelBase):
    """
    WireguardPeerUpdate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardTunnelCreate(DataModelBase):
    """
    WireguardTunnelCreate object.

    Parameters
    ----------
    keep_alive: Optional[int]
    wireguard_peer: str

    """

    keep_alive: Optional[int] = None
    wireguard_peer: str


class WorkloadDeploy(DataModelBase):
    """
    WorkloadDeploy object.

    Parameters
    ----------
    acp_name: str
    app_name: str
    app_version: Optional[str]
    name: str
    payload: Optional[Dict[str, Any]]
    title: str

    """

    acp_name: str
    app_name: str
    app_version: Optional[str] = None
    name: str = Field(..., max_length=32)
    payload: Optional[Dict[str, Any]] = None
    title: str = Field(..., max_length=64)


class WorkloadUndeployOptions(DataModelBase):
    """
    WorkloadUndeployOptions object.

    Parameters
    ----------
    keep_pvc: Optional[bool]

    """

    keep_pvc: Optional[bool] = False


class ACPMetadataBulkCreate(BaseModelRoot[ACPMetadataBulkCreateItem]):
    """
    ACPMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkCreateItem]

    """

    __root__: List[ACPMetadataBulkCreateItem]


class ACPMetadataBulkDelete(BaseModelRoot[ACPMetadataBulkDeleteItem]):
    """
    ACPMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkDeleteItem]

    """

    __root__: List[ACPMetadataBulkDeleteItem]


class ACPSettings(DataModelBase):
    """
    ACPSettings object.

    Parameters
    ----------
    auto_update: Optional[ACPSettingsAutoUpdate]
    metrics: Optional[ACPSettingsMetrics]
    status: Optional[ACPSettingsStatus]

    """

    auto_update: Optional[ACPSettingsAutoUpdate] = None
    metrics: Optional[ACPSettingsMetrics] = None
    status: Optional[ACPSettingsStatus] = None


class AnonymousTemplate(DataModelBase):
    """
    AnonymousTemplate object.

    Parameters
    ----------
    device_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    properties: Optional[List[AssetTemplateProperties]]

    """

    device_type_name: Optional[str] = None
    failure_detection: Optional[FailureDetectionTemplate] = None
    properties: Optional[List[AssetTemplateProperties]] = None


class AssetTemplateHierarchy(DataModelBase):
    """
    AssetTemplateHierarchy object.

    Parameters
    ----------
    from_template_name: Optional[str]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    template: Optional[AnonymousTemplate]
    title: Optional[str]

    """

    from_template_name: Optional[str] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = None
    template: Optional[AnonymousTemplate] = None
    title: Optional[str] = None


class AssetTemplateUpdate(DataModelBase):
    """
    AssetTemplateUpdate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    description: Optional[str]
    device_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    properties: Optional[List[AssetTemplateProperties]]
    title: Optional[str]

    """

    asset_type_name: Optional[str] = None
    description: Optional[str] = None
    device_type_name: Optional[str] = None
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = None
    hints: Optional[Dict[str, Any]] = None
    image_url: Optional[str] = None
    properties: Optional[List[AssetTemplateProperties]] = None
    title: Optional[str] = None


class ClusterCreate(DataModelBase):
    """
    ClusterCreate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    location: Optional[ClusterLocationItem]
    name: Optional[str]
    network_info: Optional[Dict[str, Any]]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    location: Optional[ClusterLocationItem] = None
    name: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class DataLabelCluster(DataModelBase):
    """
    DataLabelCluster object.

    Parameters
    ----------
    end_date: Optional[datetime]
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: Optional[datetime]
    time_bucket: Optional[str]

    """

    end_date: Optional[datetime] = None
    label_names: Optional[List[str]] = None
    metrics: Optional[List[Metric]] = None
    start_date: Optional[datetime] = None
    time_bucket: Optional[str] = None


class DataLabelCreate(DataModelBase):
    """
    DataLabelCreate object.

    Parameters
    ----------
    confidence: Optional[int]
    description: Optional[str]
    end_date: Optional[datetime]
    info: Optional[Dict[str, Any]]
    label_name: Optional[str]
    metrics: Optional[List[Metric]]
    source: Optional[DataLabelSource]
    start_date: Optional[datetime]
    validation: Optional[bool]

    """

    confidence: Optional[int] = None
    description: Optional[str] = Field(None, max_length=256)
    end_date: Optional[datetime] = None
    info: Optional[Dict[str, Any]] = None
    label_name: Optional[str] = Field(None, max_length=64)
    metrics: Optional[List[Metric]] = None
    source: Optional[DataLabelSource] = None
    start_date: Optional[datetime] = None
    validation: Optional[bool] = None


class DataLabelFilter(DataModelBase):
    """
    DataLabelFilter object.

    Parameters
    ----------
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    search: Optional[List[str]]

    """

    label_names: Optional[List[str]] = None
    metrics: Optional[List[Metric]] = None
    search: Optional[List[str]] = None


class DataLabelRange(DataModelBase):
    """
    DataLabelRange object.

    Parameters
    ----------
    end_date: Optional[datetime]
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: Optional[datetime]

    """

    end_date: Optional[datetime] = None
    label_names: Optional[List[str]] = None
    metrics: Optional[List[Metric]] = None
    start_date: Optional[datetime] = None


class DataTypeCreate(DataModelBase):
    """
    DataTypeCreate object.

    Parameters
    ----------
    icd: Optional[ICDPayload]
    schema_: Optional[Dict[str, Any]]
    source: Optional[str]

    """

    icd: Optional[ICDPayload] = None
    schema_: Optional[Dict[str, Any]] = Field(None, alias="schema")
    source: Optional[str] = None


class FailureDetection(DataModelBase):
    """
    FailureDetection object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]
    properties: Optional[List[FailureDetectionProperty]]

    """

    enabled: Optional[bool] = None
    failure_class_name: Optional[str] = None
    properties: Optional[List[FailureDetectionProperty]] = None


class InstanceSettings(DataModelBase):
    """
    InstanceSettings object.

    Parameters
    ----------
    acp: Optional[ACPSettings]

    """

    acp: Optional[ACPSettings] = None


class LabelMetadataBulkCreate(BaseModelRoot[LabelMetadataBulkCreateItem]):
    """
    LabelMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[LabelMetadataBulkCreateItem]

    """

    __root__: List[LabelMetadataBulkCreateItem]


class LabelMetadataBulkDelete(BaseModelRoot[LabelMetadataDeleteBulkItem]):
    """
    LabelMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[LabelMetadataDeleteBulkItem]

    """

    __root__: List[LabelMetadataDeleteBulkItem]


class StorageBulkCreate(DataModelBase):
    """
    StorageBulkCreate object.

    Parameters
    ----------
    data: List[StorageCreate]

    """

    data: List[StorageCreate]


class StorageLast(DataModelBase):
    """
    StorageLast object.

    Parameters
    ----------
    selectors: List[StorageSelector]

    """

    selectors: List[StorageSelector]


class StorageRangeAdvanced(DataModelBase):
    """
    StorageRangeAdvanced object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: datetime
    fill: Optional[str]
    group_by_selector: Optional[bool]
    order: Optional[Order]
    selectors: List[StorageSelector]
    start_time: datetime
    time_bucket: Optional[str]
    time_shift: Optional[str]

    """

    agg: Optional[str] = None
    end_time: datetime
    fill: Optional[str] = None
    group_by_selector: Optional[bool] = None
    order: Optional[Order] = None
    selectors: List[StorageSelector]
    start_time: datetime
    time_bucket: Optional[str] = None
    time_shift: Optional[str] = None


class ViewCreate(DataModelBase):
    """
    ViewCreate object.

    Parameters
    ----------
    metrics: Optional[List[ViewMetrics]]
    name: Optional[str]
    title: Optional[str]
    view_type_name: Optional[str]

    """

    metrics: Optional[List[ViewMetrics]] = None
    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)
    view_type_name: Optional[str] = Field(None, max_length=64)


class ViewGroupMetadataBulkCreate(BaseModelRoot[ViewGroupMetadataBulkCreateItem]):
    """
    ViewGroupMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ViewGroupMetadataBulkCreateItem]

    """

    __root__: List[ViewGroupMetadataBulkCreateItem]


class ViewGroupMetadataBulkDelete(BaseModelRoot[ViewGroupMetadataBulkDeleteItem]):
    """
    ViewGroupMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ViewGroupMetadataBulkDeleteItem]

    """

    __root__: List[ViewGroupMetadataBulkDeleteItem]


class ViewMetadataBulkCreate(BaseModelRoot[ViewMetadataBulkCreateItem]):
    """
    ViewMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ViewMetadataBulkCreateItem]

    """

    __root__: List[ViewMetadataBulkCreateItem]


class ViewMetadataBulkDelete(BaseModelRoot[ViewMetadataBulkDeleteItem]):
    """
    ViewMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ViewMetadataBulkDeleteItem]

    """

    __root__: List[ViewMetadataBulkDeleteItem]


class ViewTypeMetadataBulkCreate(BaseModelRoot[ViewTypeMetadataBulkCreateItem]):
    """
    ViewTypeMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ViewTypeMetadataBulkCreateItem]

    """

    __root__: List[ViewTypeMetadataBulkCreateItem]


class ViewTypeMetadataBulkDelete(BaseModelRoot[ViewTypeMetadataBulkDeleteItem]):
    """
    ViewTypeMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ViewTypeMetadataBulkDeleteItem]

    """

    __root__: List[ViewTypeMetadataBulkDeleteItem]


class AssetCreate(DataModelBase):
    """
    AssetCreate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    device_type_name: Optional[str]
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    name: Optional[str]
    properties: Optional[List[AssetPropertyCreate]]
    title: Optional[str]

    """

    asset_type_name: Optional[str] = Field(None, max_length=64)
    device_type_name: Optional[str] = None
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = None
    location: Optional[AssetLocationItem] = None
    name: Optional[str] = Field(None, max_length=64)
    properties: Optional[List[AssetPropertyCreate]] = None
    title: Optional[str] = Field(None, max_length=64)


class AssetTemplateCreate(DataModelBase):
    """
    AssetTemplateCreate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    description: Optional[str]
    device_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    name: Optional[str]
    properties: Optional[List[AssetTemplateProperties]]
    title: Optional[str]

    """

    asset_type_name: Optional[str] = None
    description: Optional[str] = None
    device_type_name: Optional[str] = None
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = None
    hints: Optional[Dict[str, Any]] = None
    image_url: Optional[str] = None
    name: Optional[str] = None
    properties: Optional[List[AssetTemplateProperties]] = None
    title: Optional[str] = None


class AssetUpdate(DataModelBase):
    """
    AssetUpdate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    properties: Optional[List[AssetPropertyCreate]]
    title: Optional[str]

    """

    asset_type_name: Optional[str] = Field(None, max_length=64)
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = None
    location: Optional[AssetLocationItem] = None
    properties: Optional[List[AssetPropertyCreate]] = None
    title: Optional[str] = Field(None, max_length=64)


AssetTemplateHierarchy.update_forward_refs()
AssetCreate.update_forward_refs()
